package Application;

/**
* Une Personne est caracterisee par son nom et son mot de passe
*
* @version 1.0, 2003/11/27
*/
public class Personne {

	/**
	* Mot de passe associe
	*/
	private String motDePasse;

	/**
	* Nom de la personne
	*/
	private String nom;

	/**
	* Construit une Personne a partir de son nom et de son mot de passe
	*
	* @param nom Nom de la personne
	* @param mdp Mot de passe
	*/
	protected Personne(String nom, String mdp) {
		this.nom = new String(nom);
		this.motDePasse = new String(mdp);
	}

	/**
	* Teste l'egalite entre la Personne passee en parametre et la
	* Personne courante.
	*
	* @param p Une personne
	* @return True si la personne est la meme, False sinon 
	*/
	protected boolean equals(Personne p) {
		return((p.nom()).equals(this.nom));
	}

	/**
	* Teste si le mot de passe passe en parametre est celui de la 
	* Personne courante.
	*
	* @param mdp Un mot de passe
	* @return True si le passe est le meme, False sinon
	*/
	protected boolean motDePasseOK(String mdp) {
		return(mdp.equals(this.motDePasse));
	}

	/**
	* Retourne le nom de la Personne
	*
	* @return Une chaine de caractere contenant la personne
	*/
	protected String nom() {
		return(new String(this.nom));
	}

	/**
	* Retourne une chaine de caracteres representative de la Personne
	*
	* @return La chaine de caracteres
	*/
	public String toString() {
		return(this.nom());
	}
}
