package Application;

/**
* Un Produit est caracterise par son nom et son prix unitaire
* La classe Produit represente le type d'un produit.
* (Un objet produit = nom + prix)
*
* @version 1.0, 2003/12/28
*/
public class Produit {

	/**
	* Nom du Produit
	*/
	private String nom;

	/**
	* Prix unitaire du Produit en Euros
	*/
	private Euro prixUnitaire;

	/**
	* Construit un Produit a partir de son nom et de son prix unitaire
	*
	* @param nom Nom du Produit
	* @param pu Prix unitaire du Produit en Euros
	*/
	protected Produit(String nom, Euro pu) {
		this.nom = new String(nom);
		this.prixUnitaire = (Euro)pu.clone();
	}

	/**
	* Retourne le nom du Produit
	*
	* @return Nom du Produit
	*/
	protected String nom() {
		return(new String(this.nom));
	}

	/**
	* Retourne le prix unitaire du Produit
	*
	* @return Prix unitaire du Produit en Euro
	*/
	protected Euro prixU() {
		return((Euro)prixUnitaire.clone());
	}

	/**
	* Retourne une chaine de caracteres representative du Produit
	*
	* @return Chaine de caracteres representative du Produit
	*/
	public String toString() {
		return(this.nom + " - " + this.prixUnitaire);
	}
}
