package Application;

import java.util.*;

/**
* Un Produit est caracterise par son nom et son prix unitaire
* Methodes Statiques.
*
* @version 1.0, 2003/12/28
*/
public class SDDProduit {

	/**
	* Liste de Produits stockes dans la SDD
	*/
	protected static Vector produits;

	public SDDProduit() {
	}

	/**
	* Methode statique : Permet d'ajouter un Produit dans la liste
	* 
	* @param nom Chaine de caracteres donnant le nom du Produit
	* @param prixUnitaire Prix unitaire du Produit
	*/
	protected static void ajouterProduit(String nom, Euro prixUnitaire) {

		if (!(produits instanceof Vector))
			produits = new Vector();

		produits.add(new Produit(nom, prixUnitaire));
	}

	/**
	* Methode statique : Retourne une chaine de caracteres
	* representant le contenu de la liste
	*
	* @return chaine de caracteres representative du contenu de la liste
	*/
	protected static String image() {
		StringBuffer chaine = new StringBuffer();
		int i;

		for(i = 0; i < produits.size(); i ++) {
			if(i != 0)
				chaine.append(" - ");
			chaine.append(produits.elementAt(i));
		}
		return(chaine.toString());
	}

	/**
	* Methode statique : Retourne le nom du ieme Produit de la liste
	*
	* @param i L'index du produit
	* @return nom du ieme Produit
	*/
	protected static String nomProduitAt(int i) {
		return(((Produit)(produits.elementAt(i))).nom());
	}

	/**
	* Methode statique : Permet de rechercher un Produit dans la liste
	*
	* @param nom Chaine de caracteres donnant le nom du Produit
	* @return Reference du Produit de nom : nom
	*/
	protected static Produit rechProduit(String nom) {
		Produit tmp;
		int i;

		for(i = 0; i < produits.size(); i ++) {
			if(nomProduitAt(i).equals(nom) == true)
				return((Produit)(produits.elementAt(i)));
		}
		return(null);
	}

	/**
	* Methode statique : Permet de connaitre le nombre de Produits 
	* dans la lsite
	*
	* @return nombre de Produits presents dans la liste
	*/
	protected static int size() {
		return(produits.size());
	}

	/**
	* Methode statique : Renvoit le Vector des Produits
	* (Pour affichage)
	*
	* @return un clone du Vector de produits
	*/
	protected static Vector getVector() {
		return((Vector)produits.clone());
	}
}
