package Interface;

import Application.*;

import java.util.*;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
* Class ActionWindow
* Gestion des ventes/annulation/depot/prelevement
*
* @author Patrick MARIE
* @version 1.0, 2003/1/18
*/
public class ActionWindow extends JFrame
       implements WindowListener, ActionListener {

	private MainWindow papa;
	protected Controle ctrl;

	protected JPanel mainPanel;
	protected JTabbedPane mainTabPanel;
	protected JPanel mP1, mP2;

	/* panel vente */
	JLabel mP1TText;
	JComboBox mP1CBox;
	JButton mP1Button, mP1Button2;
	JTextField mP1IText;

	/* panel compte */
	JLabel mP2TText;
	JTextField mP2IText, mP2MText;
	JPasswordField mP2PText;
	JButton mP2Button, mP2Button2; 

	/**
	* Constructeur du Frame contenant les composants d'interface
	*/
	public ActionWindow(MainWindow papa, Controle ctrl) {
		super("McGood - Actions");
		this.ctrl = ctrl;
		this.papa = papa;

		/* Taille de la fenetre */
		this.setBounds(300,300,400,300);

		/* Fenetre not resize-able */
		setResizable(false);

		/* Panneau principal */

		mainPanel = new JPanel();
		mainPanel.setLayout(new BorderLayout());

		/* Panneau avec Tabs principal */
		mainTabPanel = new JTabbedPane();

		mP1 = this.makemP1();
		mP2 = this.makemP2();

		mainTabPanel.addTab("Vente / Annulation Vente", mP1);
		mainTabPanel.addTab("Depot / Retrait", mP2);

		mainPanel.add("Center", mainTabPanel);

		this.addWindowListener(this);

		this.setContentPane(mainPanel);

		this.setVisible(true);
	}

	/* Actions */
	public void actionPerformed(ActionEvent ae) {
		Produit prodtmp;
		int i;
		double d;
		System.out.println("Action : " + ae.getActionCommand());

		if(ae.getActionCommand().equals("Valider Vente")) {
			prodtmp = (Produit)mP1CBox.getSelectedItem();

			try {
				i = Integer.valueOf(mP1IText.getText()).intValue();
				this.ctrl.nouvelleVente(this.ctrl.nomProduit(prodtmp), i);
				papa.updateWindow();
			} catch (Exception E) { 
				System.out.println(E);
			}
		}

		if(ae.getActionCommand().equals("Annuler Vente")) {
			prodtmp = (Produit)mP1CBox.getSelectedItem();
			try {
				i = Integer.valueOf(mP1IText.getText()).intValue();
				this.ctrl.annulerVenteProduit(this.ctrl.nomProduit(prodtmp), i);
				papa.updateWindow();
			} catch (Exception E) {
				System.out.println(E);
			}
		}

		if(ae.getActionCommand().equals("Depot")) {
			try {
				d = Double.valueOf(mP2MText.getText()).doubleValue();
				this.ctrl.nouveauDepot(mP2IText.getText(), new String(mP2PText.getPassword()), new Euro(d));
				papa.updateWindow();
			} catch (Exception E) {
				System.out.println(E);
			}
		}

		if(ae.getActionCommand().equals("Retrait")) {
			try {
				d = Double.valueOf(mP2MText.getText()).doubleValue();
				this.ctrl.nouveauPrelevement(mP2IText.getText(), new String(mP2PText.getPassword()), new Euro(d));
				papa.updateWindow();
			} catch (Exception E) {
				System.out.println(E);
			}
		}
	}

	/* Methodes relatives aux WindowEvent */
	public void windowActivated(WindowEvent e) {
	}

	public void windowClosed(WindowEvent e) {
	}

	public void windowClosing(WindowEvent e) {
	}

	public void windowDeactivated(WindowEvent e) {
	}

	public void windowDeiconified(WindowEvent e) {
	}

	public void windowIconified(WindowEvent e) {
	}

	public void windowOpened(WindowEvent e) {
	}

	/* Gestion clavier */
	public void keyPressed(KeyEvent e) {
	}

	public void keyTyped(KeyEvent e) {
	}

	public void keyReleased(KeyEvent e) {
	}

	/* Gestion souris */
	public void mouseClicked(MouseEvent e) {
	}

	public void mousePressed(MouseEvent e) {
	}

	public void mouseReleased(MouseEvent e) {
	}

	public void mouseEntered(MouseEvent e) {
	}

	public void mouseExited(MouseEvent e) {
	}

	/* Creation Panel Vente / Annulation Vente */
	public JPanel makemP1() {
		JPanel tmp = new JPanel();
		tmp.setLayout(new FlowLayout());

		mP1TText = new JLabel("Nouvelle Vente / Annulation d'une vente");
		mP1CBox = new JComboBox(this.ctrl.getProduitVector());

		mP1IText = new JTextField();
		mP1IText.setColumns(3); 

		mP1Button = new JButton("Valider Vente");
		mP1Button.addActionListener(this);

		mP1Button2 = new JButton("Annuler Vente");
		mP1Button2.addActionListener(this);

		tmp.add(mP1TText);
		tmp.add(mP1IText);
		tmp.add(mP1CBox);
		tmp.add(mP1Button);
		tmp.add(mP1Button2);

		return(tmp);
	}

	/* Creation Panel Depot / Retrait */
	public JPanel makemP2() {
		JPanel tmp = new JPanel();
		tmp.setLayout(new FlowLayout());

		mP2TText = new JLabel("Nouveau depot / Nouveau Retrait");

		mP2IText = new JTextField();
		mP2IText.setColumns(10);
		mP2PText = new JPasswordField();
		mP2PText.setColumns(10);

		mP2MText = new JTextField();
		mP2MText.setColumns(7);

		mP2Button = new JButton("Depot");
		mP2Button.addActionListener(this);

		mP2Button2 = new JButton("Retrait");
		mP2Button2.addActionListener(this);

		tmp.add(mP2TText);
		tmp.add(mP2IText);
		tmp.add(mP2PText);
		tmp.add(mP2MText);
		tmp.add(mP2Button);
		tmp.add(mP2Button2);

		return(tmp);
	}
}
