package Interface;

import Application.*;

import java.util.*;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
* Class MainWindow
* Gestion de l'interface de l'application effectuee grace a un Frame
* qui contient tous les composants graphiques necessaires
*
* @author Patrick MARIE 
* @version 1.0, 2004/1/10
*/
public class MainWindow extends JFrame 
       implements WindowListener, ActionListener {

	protected Controle ctrl;

	protected JPanel mainPanel;
	protected JTabbedPane mainTabPanel;
	protected JPanel mP1, mP2, mP3, mP4, mP5;

	protected JLabel mP1cpt;

	protected JScrollPane mP2subPane;
	protected JList mP2List;

	protected JScrollPane mP3subPane;
	protected JList mP3List;

	protected JScrollPane mP4subPane;
	protected JList mP4List;

	protected JScrollPane mP5subPane;
	protected JButton mP5button1;
	protected JLabel mP5labreset;

	protected JButton ButtonQuitter;

	protected ActionWindow myActionWindow;

	/**
	* Constructeur du Frame contenant les composants d'interface
	*/
	public MainWindow(Controle ctrl) {
		super("McGood - Gestion d'entreprise");

		/* Initialiastion de la variable ctrl a la classe Controle */
		this.ctrl = ctrl;

		/* On quitte a la fermeture */
		this.setDefaultCloseOperation(EXIT_ON_CLOSE);

		/* Taille de la fenetre */
		this.setBounds(200,200,400,300);

		/* Fenetre not resize-able */
		setResizable(false);

		/* Panneau principal */
		mainPanel = new JPanel();
		mainPanel.setLayout(new BorderLayout());

		/* Bouton dans le panneau principal */
		ButtonQuitter = new JButton("Quitter");
		ButtonQuitter.addActionListener(this);
		mainPanel.add("South", ButtonQuitter);

		/* Panneau avec Tabs principal */
		mainTabPanel = new JTabbedPane();
		mP1 = makemP1();
		mP2 = makemP2();
		mP3 = makemP3();
		mP4 = makemP4();
		mP5 = makemP5();

		mainTabPanel.addTab("General", mP1);
		mainTabPanel.addTab("Produits", mP2);
		mainTabPanel.addTab("Clients", mP3);
		mainTabPanel.addTab("Lignes Comptables", mP4);
		mainTabPanel.addTab("Reset compte", mP5);

		mainPanel.add("Center", mainTabPanel);

		this.addWindowListener(this);

		this.setContentPane(mainPanel);

		this.setVisible(true);

		/* Ouverture de la 2nd fenetre en // */
		myActionWindow = new ActionWindow(this, ctrl);
	}

	/**
	* Gestion des evenements recus apres un clic
	*/
	public void actionPerformed(ActionEvent ae) {
		System.out.println("Action : " + ae.getActionCommand());

		if(ae.getActionCommand().equals("Quitter")) {
			this.ctrl.close();
			System.exit(0);
		}

		if(ae.getActionCommand().equals("Reset")) {
			this.ctrl.reset();
			this.updateWindow();
		}
	}

	/* Methodes relatives aux WindowEvent */
	public void windowActivated(WindowEvent e) {
	}

	public void windowClosed(WindowEvent e) {
	}

	public void windowClosing(WindowEvent e) {
		this.ctrl.close();
		System.exit(0);
	}

	public void windowDeactivated(WindowEvent e) {
	}

	public void windowDeiconified(WindowEvent e) {
	}

	public void windowIconified(WindowEvent e) {
	}

	public void windowOpened(WindowEvent e) {
	}

	/* Gestion clavier */

	public void keyPressed(KeyEvent e) {
	}

	public void keyTyped(KeyEvent e) {
	}

	public void keyReleased(KeyEvent e) {
	}

	/* Gestion souris */

	public void mouseClicked(MouseEvent e) {
	}

	public void mousePressed(MouseEvent e) {
	}

	public void mouseReleased(MouseEvent e) {
	}

	public void mouseEntered(MouseEvent e) {
	}

	public void mouseExited(MouseEvent e) {
	}

	/* Creation Panel General */
	public JPanel makemP1() {
		JPanel tmp = new JPanel();

		mP1cpt = new JLabel(this.ctrl.etatDuCompte()); 

		tmp.add(mP1cpt);

		return(tmp);
	}

	/* Creation Panel Liste Produits */
	public JPanel makemP2() {
		JPanel tmp = new JPanel();
		Vector lp = this.ctrl.getProduitVector();

		mP2List = new JList(lp);
		mP2subPane = new JScrollPane(mP2List);
		tmp.add(mP2subPane); 

		return(tmp);
	}

	/* Creation Panel Liste Clients */
	public JPanel makemP3() {
		JPanel tmp = new JPanel();
		Vector lp = this.ctrl.getPersonneVector();

		mP3List = new JList(lp);
		mP3subPane = new JScrollPane(mP3List);
		tmp.add(mP3subPane);

		return(tmp);
	}

	/* Creation Panel Lignes Comptable */
	public JPanel makemP4() {
		JPanel tmp = new JPanel();
		Vector lp = this.ctrl.getLignesComptables();

		mP4List = new JList(lp);
		mP4subPane = new JScrollPane(mP4List);
		tmp.add(mP4subPane);

		return(tmp);
	}

	/* Creation Panel Reset */
	public JPanel makemP5() {
		JPanel tmp = new JPanel();
		mP5labreset = new JLabel("Reset du compte");
		tmp.setLayout(new BorderLayout());

		mP5button1 = new JButton("Reset");
		mP5button1.addActionListener(this);

		tmp.add("North", mP5labreset);
		tmp.add("Center", mP5button1);

		return(tmp);
	}

	/**
	* Mise a jour des donnees (LigneComptable + compte)
	*/
	public void updateWindow() {

		mP4List.setListData(this.ctrl.getLignesComptables());
		mP4List.updateUI();

		mP1cpt.setText(this.ctrl.etatDuCompte());
		mP1cpt.updateUI();

	}
}
